Index: cprs/trunk/CPRS-Chart/fGraphs.pas
===================================================================
--- cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 830)
@@ -2460,4 +3175,200 @@
   chkDualViews.Checked := not chkDualViews.Checked;
   chkDualViewsClick(self);
+end;
+
+procedure TfrmGraphs.mnuPopGraphExportClick(Sender: TObject);
+
+  procedure AddRow(worksheet: variant;
+    linestring, typename, itemname, date1, date2, result, other: string);
+  begin
+    worksheet.range('A' + linestring) := typename;
+    worksheet.range('B' + linestring) := itemname;
+    worksheet.range('C' + linestring) := date1;
+    worksheet.range('D' + linestring) := date2;
+    worksheet.range('E' + linestring) := result;
+    worksheet.range('F' + linestring) := other;
+  end;
+
+var
+  ok, topflag: boolean;
+  i, j, cnt: integer;
+  dtdata1, dtdata2, dtdate1, dtdate2: double;
+  StrForFooter, StrForHeader, aTitle, aDateRange, aCustomDateRange: String;
+  cdate, itemtype, item, itemtypename, itemname, typeitem, specnum: String;
+  datax, fmdate1, fmdate2, linestring: String;
+  aHeader: TStringList;
+  aGraphItem: TGraphItem;
+  aListItem: TListItem;
+  excelApp, workbook, worksheet: Variant;
+begin
+  if (lvwItemsTop.SelCount = 0) and (lvwItemsBottom.SelCount = 0) then
+  begin
+    ShowMessage('No Items selected.');
+    exit;
+  end;
+  try
+    excelApp := CreateOleObject('Excel.Application');
+  except
+    raise Exception.Create('Cannot start MS Excel!');
+  end;
+  topflag := mnuPopGraphStayOnTop.Checked and mnuPopGraphStayOnTop.Enabled;
+  Screen.Cursor := crDefault;
+  aTitle := 'CPRS Graphing';
+  dtdate1 := FGraphSetting.FMStartDate; //DateTimeToFMDateTime(FGraphSetting.LowTime);
+  dtdate2 := FGraphSetting.FMStopDate; //DateTimeToFMDateTime(FGraphSetting.HighTime);
+  dtdate1 := FMDateTimeOffsetBy(dtdate1, 1);   // add a day to start
+  dtdate2 := dtdate2;
+
+  if (length(cboDateRange.Text) < 25) and
+     (cboDateRange.Text <> 'All Results') and
+     (cboDateRange.Text <> 'Today') then
+    aDateRange :=  'Date Range: ' + cboDateRange.Text + '  Selected Items from ' +
+      FormatFMDateTime('mm/dd/yy', dtdate1) + ' to ' +
+      FormatFMDateTime('mm/dd/yy', dtdate2)
+  else
+    aDateRange :=  'Date Range: Selected Items from ' + cboDateRange.Text;
+  dtdate1 := DateTimeToFMDateTime(FGraphSetting.LowTime);
+  dtdate2 := DateTimeToFMDateTime(FGraphSetting.HighTime);
+  aCustomDateRange := cboDateRange.Items[cboDateRange.ItemIndex];
+  if Piece(aCustomDateRange, '^', 1) = '' then           // custom date range
+  begin
+    dtdate1 := strtofloat(Piece(aCustomDateRange, '^', 6));
+    dtdate2 := strtofloat(Piece(aCustomDateRange, '^', 7));
+  end;
+  aHeader := TStringList.Create;
+  CreateExcelPatientHeader(aHeader, aTitle, aDateRange);
+  StrForHeader := '';
+  for i := 0 to aHeader.Count - 1 do 
+  begin
+    StrForHeader := StrForHeader + aHeader[i] + #13;
+  end;
+  if length(StrForHeader) > 250 then
+    StrForHeader := copy(StrForHeader, 1, 250) + #13;  // VB script in Excel is limited to 253
+  StrForFooter := aTitle + '                    *** WORK COPY ONLY ***                            '
+                + 'Printed: ' + FormatDateTime('mmm dd, yyyy  hh:nn', Now) + #13
+                + TXT_COPY_DISCLAIMER + #13;
+  excelApp.Visible := true;
+  workbook := excelApp.workbooks.add;
+  worksheet := workbook.worksheets.add;
+  worksheet.name := aTitle;
+  worksheet.PageSetup.PrintArea := '';
+  worksheet.PageSetup.TopMargin := 110;
+  worksheet.PageSetup.CenterHeader := StrForHeader;
+  worksheet.PageSetup.BottomMargin := 75;
+  worksheet.PageSetup.LeftFooter := StrForFooter;
+  worksheet.PageSetup.RightFooter := 'Page &P of &N';
+  worksheet.PageSetup.PrintTitleRows := '$1:$1';
+  worksheet.PageSetup.PrintTitleColumns := '$A:$F';
+  AddRow(worksheet, '1', 'Type', 'Item', 'Date', 'End Date', 'Value', 'Other');
+  cnt := 1;
+  aListItem := lvwItemsTop.Selected;
+  while aListItem <> nil do
+  begin
+    itemname := aListItem.Caption;
+    itemtypename := aListItem.SubItems[0];
+    aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+    typeitem := UpperCase(aGraphItem.Values);
+    if Piece(typeitem, '^', 1) = '63' then
+    begin
+      specnum := Piece(Piece(typeitem, '^', 2), '.', 2);
+      if length(specnum) > 0 then  // multispecimen
+        if specnum = '1' then
+          typeitem := Piece(typeitem, '.', 1)
+        else
+          typeitem := '';
+    end;
+    itemtype := Piece(typeitem, '^', 1);
+    item := Piece(typeitem, '^', 2);
+    for j := 0 to GtslData.Count - 1 do
+    begin
+      datax := GtslData[j];
+      if Piece(datax, '^', 1) = itemtype then
+        if Piece(datax, '^', 2) = item then
+        begin
+          dtdata1 := strtofloatdef(Piece(datax, '^', 3), -1);
+          fmdate1 := FormatFMDateTime('mm/dd/yy hh:nn', dtdata1);
+          if copy(fmdate1, length(fmdate1) - 5, length(fmdate1)) = ' 00:00' then
+            fmdate1 := copy(fmdate1, 1, length(fmdate1) - 5) + '     ';
+          cdate := Piece(datax, '^', 4);
+          if Piece(cdate, '.', 2) = '24' then cdate := Piece(cdate, '.', 1) + '.2359';
+          dtdata2 := strtofloatdef(cdate, -1);      // restrict to within date range
+          fmdate2 := FormatFMDateTime('mm/dd/yy hh:nn', dtdata2);
+          if copy(fmdate2, length(fmdate2) - 5, length(fmdate2)) = ' 00:00' then
+            fmdate2 := copy(fmdate2, 1, length(fmdate2) - 5) + '     ';
+          if dtdata2 > 0 then            
+            ok := (dtdata1 <= dtdate2) and (dtdata2 >= dtdate1) // overlap for durations
+          else
+            ok := (dtdata1 >= dtdate1) and (dtdata1 <= dtdate2); // inclusion for instances
+          if ok then
+          begin
+            cnt := cnt + 1;
+            linestring := inttostr(cnt);
+            AddRow(worksheet, linestring, itemtypename, itemname, fmdate1, fmdate2, Piece(datax, '^', 5), Piece(datax, '^', 8));
+          end;
+        end;
+    end;
+    aListItem := lvwItemsTop.GetNextItem(aListItem, sdAll, [isSelected]);
+  end;
+  if lvwItemsBottom.Items.Count > 0 then        //rewrite to combine
+  begin
+    cnt := cnt + 1;
+    linestring := inttostr(cnt);
+    AddRow(worksheet, linestring, '', '', '', '', '', '');
+    aListItem := lvwItemsBottom.Selected;
+    while aListItem <> nil do
+    begin
+      itemname := aListItem.Caption;
+      itemtypename := aListItem.SubItems[0];
+      aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+      typeitem := UpperCase(aGraphItem.Values);
+      if Piece(typeitem, '^', 1) = '63' then
+      begin
+        specnum := Piece(Piece(typeitem, '^', 2), '.', 2);
+        if length(specnum) > 0 then  // multispecimen
+          if specnum = '1' then
+            typeitem := Piece(typeitem, '.', 1)
+          else
+            typeitem := '';
+      end;
+      itemtype := Piece(typeitem, '^', 1);
+      item := Piece(typeitem, '^', 2);
+      for j := 0 to GtslData.Count - 1 do
+      begin
+        datax := GtslData[j];
+        if Piece(datax, '^', 1) = itemtype then
+          if Piece(datax, '^', 2) = item then
+          begin
+            dtdata1 := strtofloatdef(Piece(datax, '^', 3), -1);
+            fmdate1 := FormatFMDateTime('mm/dd/yy hh:nn', dtdata1);
+            if copy(fmdate1, length(fmdate1) - 5, length(fmdate1)) = ' 00:00' then
+              fmdate1 := copy(fmdate1, 1, length(fmdate1) - 5) + '     ';
+            cdate := Piece(datax, '^', 4);
+            if Piece(cdate, '.', 2) = '24' then cdate := Piece(cdate, '.', 1) + '.2359';
+            dtdata2 := strtofloatdef(cdate, -1);
+            fmdate2 := FormatFMDateTime('mm/dd/yy hh:nn', dtdata2);
+            if copy(fmdate2, length(fmdate2) - 5, length(fmdate2)) = ' 00:00' then
+              fmdate2 := copy(fmdate2, 1, length(fmdate2) - 5) + '     ';
+            if dtdata2 > 0 then            
+              ok := (dtdata1 <= dtdate2) and (dtdata2 >= dtdate1) // overlap for durations
+            else
+              ok := (dtdata1 >= dtdate1) and (dtdata1 <= dtdate2); // inclusion for instances
+            if ok then
+            begin
+              cnt := cnt + 1;
+              linestring := inttostr(cnt);
+              AddRow(worksheet, linestring, itemtypename, itemname, fmdate1, fmdate2, Piece(datax, '^', 5), Piece(datax, '^', 8));
+            end;
+          end;
+      end;
+      aListItem := lvwItemsBottom.GetNextItem(aListItem, sdAll, [isSelected]);
+    end;
+  end;
+  worksheet.Range['A1', 'F' + LineString].Columns.AutoFit;
+  worksheet.Range['A1', 'F' + LineString].Select;
+  worksheet.Range['A1', 'F' + LineString].AutoFormat(12, true, true, true, true, true, true);
+
+  if topflag then
+    mnuPopGraphStayOnTopClick(self);
+  Screen.Cursor := crDefault;
 end;
 
@@ -2499,4 +3410,22 @@
   with FGraphSetting do Legend := not Legend;
   ChangeStyle;
+end;
+
+procedure TfrmGraphs.ChartColor(aColor: TColor);
+begin
+  chartDatelineTop.Color := aColor;
+  chartDatelineTop.Legend.Color := aColor;
+  pnlDatelineTopSpacer.Color := aColor;
+  scrlTop.Color := aColor;
+  pnlTopRightPad.Color := aColor;
+  pnlScrollTopBase.Color := aColor;
+  pnlBlankTop.Color := aColor;
+  chartDatelineBottom.Color := aColor;
+  chartDatelineBottom.Legend.Color := aColor;
+  pnlDatelineBottomSpacer.Color := aColor;
+  scrlBottom.Color := aColor;
+  pnlBottomRightPad.Color := aColor;
+  pnlScrollBottomBase.Color := aColor;
+  pnlBlankBottom.Color := aColor;
 end;
 
@@ -2538,7 +3467,9 @@
       if Series[j] is TPointSeries then
         with (Series[j] as TPointSeries) do
+        if Pointer.Style <> psSmallDot then      // keep non-numeric label unchanged
         begin
           Marks.Visible := FGraphSetting.Values;
           LinePen.Visible := FGraphSetting.Lines;
+          if Title = '(non-numeric)' then Marks.Visible := FDisplayFreeText;
         end;
       if Series[j] is TBarSeries then
@@ -2585,37 +3516,7 @@
     ChartStyle(chartDateLineBottom);
   if FGraphSetting.ClearBackground then
-  begin
-    chartDatelineTop.Color := ClearColor;
-    chartDatelineTop.Legend.Color := ClearColor;
-    pnlDatelineTopSpacer.Color := ClearColor;
-    scrlTop.Color := ClearColor;
-    pnlTopRightPad.Color := ClearColor;
-    pnlScrollTopBase.Color := ClearColor;
-    pnlBlankTop.Color := ClearColor;
-    chartDatelineBottom.Color := ClearColor;
-    chartDatelineBottom.Legend.Color := ClearColor;
-    pnlDatelineBottomSpacer.Color := ClearColor;
-    scrlBottom.Color := ClearColor;
-    pnlBottomRightPad.Color := ClearColor;
-    pnlScrollBottomBase.Color := ClearColor;
-    pnlBlankBottom.Color := ClearColor;
-  end
+    ChartColor(ClearColor)
   else
-  begin
-    chartDatelineTop.Color := OriginalColor;
-    chartDatelineTop.Legend.Color := clCream;
-    pnlDatelineTopSpacer.Color := OriginalColor;
-    scrlTop.Color := OriginalColor;
-    pnlTopRightPad.Color := OriginalColor;
-    pnlScrollTopBase.Color := OriginalColor;
-    pnlBlankTop.Color := OriginalColor;
-    chartDatelineBottom.Color := OriginalColor;
-    chartDatelineBottom.Legend.Color := clCream;
-    pnlDatelineBottomSpacer.Color := OriginalColor;
-    scrlBottom.Color := OriginalColor;
-    pnlBottomRightPad.Color := OriginalColor;
-    pnlScrollBottomBase.Color := OriginalColor;
-    pnlBlankBottom.Color := OriginalColor;
-  end;
+    ChartColor(OriginalColor);
   mnuPopGraphLines.Checked := FGraphSetting.Lines;
   mnuPopGraph3D.Checked := FGraphSetting.View3D;
@@ -2636,6 +3537,12 @@
   ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
 var
-  dttm, seriestitle, textvalue, textvalue1, textvalue2, typename, typenum: string;
-begin
+  lbutton: boolean;
+begin
+  if FOnMark then       // action already taken by mousedown on a mark
+  begin
+    FOnMark := false;
+    exit;
+  end;
+  FOnMark := false;
   timHintPause.Enabled := false;
   InactivateHint;
@@ -2654,8 +3561,18 @@
     FDate2 := FDate1;
   end;
-  seriestitle := Series.Title;
-  if Button <> mbRight then
-  begin
-    textvalue := ValueText(Sender, Series, ValueIndex);
+  lbutton := Button <> mbRight;
+  SeriesClicks(Sender as TChart, Series, ValueIndex, lbutton);
+  FMouseDown := false;
+end;
+
+
+procedure TfrmGraphs.SeriesClicks(aChart: TChart; aSeries: TChartSeries; aIndex: integer; lbutton: boolean);
+var
+  originalindex: integer;
+  dttm, seriestitle, showing, textvalue, textvalue1, textvalue2, typename, typenum: string;
+begin
+  if lbutton then
+  begin
+    textvalue := ValueText(aChart, aSeries, aIndex);
     dttm := Piece(textvalue, '^', 3);
     if copy(textvalue, length(textvalue) - 5, length(textvalue)) = ' 00:00' then
@@ -2669,4 +3586,10 @@
   else
   begin
+    seriestitle := Piece(aSeries.Title, '^', 1);
+    if seriestitle = '(non-numeric)' then
+    begin
+      originalindex := strtointdef(Piece(GtslNonNum[aIndex], '^', 3), 0);
+      seriestitle := Piece(aChart.Series[originalindex].Title, '^', 1);
+    end;
     mnuPopGraphIsolate.Enabled := true;
     if pnlTop.Tag = 1 then
@@ -2676,11 +3599,13 @@
     scrlTop.Hint := 'Details - for ' + seriestitle + ' for ' +
       FormatDateTime('mmm d, yyyy  h:nn am/pm', FDate1);
-    scrlTop.Tag := ValueIndex + 1;
+    scrlTop.Tag := aIndex + 1;
     mnuPopGraphIsolate.Hint := seriestitle;
     mnuPopGraphRemove.Enabled := true;
     mnuPopGraphRemove.Caption := 'Remove - ' + seriestitle;
     mnuPopGraphDetails.Caption := 'Details - ' + seriestitle;
-  end;
-  FMouseDown := false;
+    if FGraphSeries.Marks.Visible then showing := ' - turn off' else showing := ' - turn on';
+    mnuPopGraphValueMarks.Caption := 'Values - ' + seriestitle + showing;
+    mnuPopGraphValueMarks.Enabled := true;
+  end;
 end;
 
@@ -2688,6 +3613,6 @@
 var
   i: integer;
-  dttm, datax, datex1, datex2, fmdate1, fmdate2, newdata, newline, oldline, spacer, titlemsg: string;
-  dt1, dt2, dtdata, dtdata1, dtdata2: double;
+  datex1, datex2, newline, oldline, spacer, titlemsg: string;
+  dt1, dt2: double;
   tmpOtherList, templist: TStringList;
 begin
@@ -2704,7 +3629,48 @@
   dt2 := strtofloatdef(datex2, BIG_NUMBER);
   CheckToAddData(lvwItemsTop, 'top', aType);    // if type is not loaded - load data
-  for i := 0 to lstData.Items.Count - 1 do
-  begin
-    datax := lstData.Items[i];
+  TempData(tmpOtherList, aType, dt1, dt2);
+  with tmpOtherList do
+  begin
+    Sort;
+    for i := Count - 1 downto 0 do
+    begin
+      newline := '';
+      oldline := tmpOtherList[i];
+      newline := Piece(oldline, '^', 4) + '   ' + Piece(oldline, '^', 5);
+      spacer := Copy(BIG_SPACES, 1, 40 - length(newline));
+      newline := newline + spacer + ' ' + Piece(oldline, '^', 3);
+      templist.Add(newline);
+    end;
+    Clear;
+    FastAssign(templist, tmpOtherList);
+    //Assign(templist);
+    if aDate <> aDate2 then
+      titlemsg := aTypeName + ' occurences for ' + FormatDateTime('mmm d, yyyy', aDate) +
+        ' - ' + FormatDateTime('mmm d, yyyy', aDate2)
+    else
+      titlemsg := aTypeName + ' occurences for ' + FormatDateTime('mmm d, yyyy', aDate);
+    Insert(0, firstline);
+    Insert(1, secondline);
+    Insert(2, '');
+    Insert(3, 'All ' + titlemsg + ':');
+    Insert(4, '');
+    Insert(0, TXT_REPORT_DISCLAIMER);
+    Insert(1, '');
+    ReportBox(tmpOtherList, titlemsg, true);
+  end;
+  tmpOtherList.Free;
+  templist.Free;
+  Screen.Cursor := crDefault;
+end;
+
+procedure TfrmGraphs.TempData(aStringList: TStringList; aType: string; dt1, dt2: double);
+var
+  i: integer;
+  dttm, datax, fmdate1, fmdate2, newdata: string;
+  dtdata, dtdata1, dtdata2: double;
+begin
+  for i := 0 to GtslData.Count - 1 do
+  begin
+    datax := GtslData[i];
     if Piece(datax, '^', 1) = aType then
     begin
@@ -2727,5 +3693,5 @@
                      ItemName(aType, Piece(datax, '^', 2)) + '^' +
                      Piece(datax, '^', 5);
-          tmpOtherList.Add(MixedCase(newdata));
+          aStringList.Add(MixedCase(newdata));
         end;
       end
@@ -2744,44 +3710,10 @@
           dttm + '^' +
           ItemName(aType, Piece(datax, '^', 2));
-          tmpOtherList.Add(MixedCase(newdata));
+          aStringList.Add(MixedCase(newdata));
         end;
       end;
     end;
   end;
-  with tmpOtherList do
-  begin
-    Sort;
-    for i := Count - 1 downto 0 do
-    begin
-      newline := '';
-      oldline := tmpOtherList[i];
-      newline := Piece(oldline, '^', 4) + '   ' +
-        Piece(oldline, '^', 5);
-        spacer := Copy(BIG_SPACES, 1, 40 - length(newline));
-      newline := newline + spacer + ' ' +
-        Piece(oldline, '^', 3);
-      templist.Add(newline);
-    end;
-    Clear;
-    Assign(templist);
-    if aDate <> aDate2 then
-      titlemsg := aTypeName + ' occurences for ' + FormatDateTime('mmm d, yyyy', aDate) +
-        ' - ' + FormatDateTime('mmm d, yyyy', aDate2)
-    else
-      titlemsg := aTypeName + ' occurences for ' + FormatDateTime('mmm d, yyyy', aDate);
-    Insert(0, firstline);
-    Insert(1, secondline);
-    Insert(2, '');
-    Insert(3, 'All ' + titlemsg + ':');
-    Insert(4, '');
-    Insert(0, TXT_REPORT_DISCLAIMER);
-    Insert(1, '');
-    ReportBox(tmpOtherList, titlemsg, true);
-  end;
-  tmpOtherList.Free;
-  templist.Free;
-  Screen.Cursor := crDefault;
-end;
-
+end;
 
 procedure TfrmGraphs.ItemDateRange(Sender: TCustomChart);
@@ -2819,5 +3751,5 @@
     seriestitle := Sender.Series[i].Title;
     if seriestitle = 'Blood Pressure' then
-      if bpnotdone = false then ok := false;
+      if not bpnotdone then ok := false;
     if ok then
     begin
@@ -2859,32 +3791,26 @@
   aGraphItem: TGraphItem;
   aListView, aOtherListView: TListView;
+  aListItem: TListItem;
 begin
   FFirstClick := true;
-  cboViewsTop.ItemIndex := -1;
-  cboViewsTop.Text := '';
-  cboViewsBottom.ItemIndex := -1;
-  cboViewsBottom.Text := '';
+  lstViewsTop.ItemIndex := -1;
+  lstViewsBottom.ItemIndex := -1;
   if pnlTop.Tag = 1 then
   begin
-    aListView := lvwItemsTop;
-    aOtherListView := lvwItemsBottom;
-    aSection := 'top';
-    aOtherSection := 'bottom';
+    aListView := lvwItemsTop;       aOtherListView := lvwItemsBottom;
+    aSection := 'top';              aOtherSection := 'bottom';
   end
   else
   begin
-    aListView := lvwItemsBottom;
-    aOtherListView := lvwItemsTop;
-    aSection := 'bottom';
-    aOtherSection := 'top';
+    aListView := lvwItemsBottom;    aOtherListView := lvwItemsTop;
+    aSection := 'bottom';           aOtherSection := 'top';
   end;
   if aListView.SelCount = 0 then exit;
   if StripHotKey(mnuPopGraphIsolate.Caption) = ('Move all selections to ' + aOtherSection) then
   begin
-    with aListView do
-    for i := 0 to Items.Count - 1 do
-    if Items[i].Selected then
-    begin
-      aGraphItem := TGraphItem(Items.Item[i].SubItems.Objects[3]);
+    aListItem := aListView.Selected;
+    while aListItem <> nil do
+    begin
+      aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
       typeitem := Pieces(aGraphItem.Values, '^', 1, 2);
       for j := 0 to aOtherListView.Items.Count - 1 do
@@ -2894,15 +3820,7 @@
           aOtherListView.Items[j].Selected := true;
       end;
-      Items[i].Selected := false;
-    end;
-    with chkDualViews do
-    if not Checked then
-    begin
-      Checked := true;
-      Click;
-    end;
-    ChangeStyle;
-    DisplayData(aSection);
-    DisplayData(aOtherSection);
+      aListItem.Selected := false;
+      aListItem := aListView.GetNextItem(aListItem, sdAll, [isSelected]);
+    end;
   end
   else
@@ -2917,14 +3835,14 @@
     end;
     aListView.Items[selnum].Selected := false;
-    with chkDualViews do
-    if not Checked then
-    begin
-      Checked := true;
-      Click;
-    end;
-    ChangeStyle;
-    DisplayData(aSection);
-    DisplayData(aOtherSection);
-  end;
+  end;
+  with chkDualViews do
+  if not Checked then
+  begin
+    Checked := true;
+    Click;
+  end;
+  ChangeStyle;
+  DisplayData(aSection);
+  DisplayData(aOtherSection);
   mnuPopGraphIsolate.Enabled := false;
 end;
@@ -2967,4 +3885,6 @@
 procedure TfrmGraphs.chartBaseMouseDown(Sender: TObject; Button: TMouseButton;
   Shift: TShiftState; X, Y: Integer);
+var
+  lbutton: boolean;
 begin
   FHintStop := true;
@@ -2984,4 +3904,6 @@
     mnuPopGraphIsolate.Caption := 'Move all selections to bottom';
     mnuPopGraphRemove.Caption := 'Remove all selections from top';
+    if memTop.Visible then
+      memTop.SetFocus;
   end
   else
@@ -2989,7 +3911,115 @@
     mnuPopGraphIsolate.Caption := 'Move all selections to top';
     mnuPopGraphRemove.Caption := 'Remove all selections from bottom';
-  end;
-  If Button = mbLeft then
+    if memBottom.Visible then
+      memBottom.SetFocus;
+  end;
+  if Button = mbLeft then
     FMouseDown := true;
+  lbutton := Button <> mbRight;
+  MouseClicks(Sender as TChart, lbutton, X, Y);
+end;
+
+procedure TfrmGraphs.MouseClicks(aChart: TChart; lbutton: boolean; X, Y: Integer);
+var
+  i, tmp: integer;
+  aSeries: TChartSeries;
+begin
+  tmp := -1;
+  for i := 0 to aChart.SeriesCount - 1 do
+  if aChart.Series[i].Marks.Visible then
+  begin
+    tmp := aChart.Series[i].Marks.Clicked(X, Y);
+    if tmp <> -1 then break;
+  end;
+  if tmp <> -1 then
+  begin
+    FOnMark := true;
+    aSeries := aChart.Series[i];
+    FGraphClick := aChart;
+    FGraphSeries := aSeries;
+    FGraphValueIndex := tmp;
+    chartDateLineTop.Tag := 1;       // indicates a series click
+    if (aSeries is TGanttSeries) then
+    begin
+      FDate1 := (aSeries as TGanttSeries).StartValues[tmp];
+      FDate2 := (aSeries as TGanttSeries).EndValues[tmp];
+    end
+    else
+    begin
+      FDate1 := aSeries.XValue[tmp];
+      FDate2 := FDate1;
+    end;
+    LabelClicks(aChart, aSeries, lbutton, tmp);
+    FMouseDown := false;
+    aChart.AllowZoom := false;
+  end;
+end;
+
+procedure TfrmGraphs.LabelClicks(aChart: TChart; aSeries: TChartSeries; lbutton: boolean; tmp: integer);
+var
+  firstnon, toggle: boolean;
+  i, originalindex: integer;
+  dttm, seriestitle, showing, textvalue, textvalue1, textvalue2, typename, typenum: string;
+begin
+    seriestitle := Piece(aSeries.Title, '^', 1);
+    if seriestitle = '(non-numeric)' then
+    begin
+      originalindex := strtointdef(Piece(GtslNonNum[tmp], '^', 3), 0);
+      seriestitle := Piece(aChart.Series[originalindex].Title, '^', 1);
+    end;
+    if (seriestitle = TXT_COMMENTS) and lbutton then
+    begin
+      chartDatelineTop.Tag := 0;
+      mnuPopGraphDetailsClick(self);
+    end
+    else if (seriestitle = TXT_NONNUMERICS) and lbutton then
+    begin
+      if (aSeries.Identifier = 'serNonNumBottom') or (aSeries.Identifier = 'serNonNumTop') then
+      begin
+        firstnon := true;
+        toggle := false;
+        for i := 0 to aChart.SeriesCount - 1 do
+        if Piece(aChart.Series[i].Title, '^', 1) = '(non-numeric)' then
+        begin
+          if firstnon then
+          begin
+           toggle := not aChart.Series[i].Marks.Visible;
+           firstnon := false;
+          end;
+          aChart.Series[i].Marks.Visible := toggle;
+        end;
+      end;
+    end
+    else if lbutton and (seriestitle <> TXT_NONNUMERICS) then
+    begin
+      textvalue := ValueText(aChart, aSeries, tmp);
+      dttm := Piece(textvalue, '^', 3);
+      if copy(textvalue, length(textvalue) - 5, length(textvalue)) = ' 00:00' then
+        dttm := Pieces(dttm, ' ', 1, 3);
+      textvalue1 := Piece(textvalue, '^', 2) + '  ' + dttm;
+      textvalue2 := Piece(textvalue, '^', 4) + '  ' + Piece(textvalue, '^', 5);
+      typenum := trim(Piece(textvalue, '^', 1));
+      typename := Piece(textvalue, '^', 2);
+      AllTypeDate(typenum, typename, textvalue1, textvalue2, FDate1, FDate2);
+    end
+    else if (Piece(aSeries.Title, '^', 1) <> TXT_NONNUMERICS)
+        and (Piece(aSeries.Title, '^', 1) <> TXT_COMMENTS) then
+    begin
+      mnuPopGraphIsolate.Enabled := true;
+      if pnlTop.Tag = 1 then
+        mnuPopGraphIsolate.Caption := 'Move - ' + seriestitle + ' - from Top to Bottom'
+      else
+        mnuPopGraphIsolate.Caption := 'Move - ' + seriestitle + ' - from Bottom to Top';
+      scrlTop.Hint := 'Details - for ' + seriestitle + ' for ' +
+        FormatDateTime('mmm d, yyyy  h:nn am/pm', FDate1);
+      scrlTop.Tag := tmp + 1;
+      mnuPopGraphIsolate.Hint := seriestitle;
+      mnuPopGraphRemove.Enabled := true;
+      mnuPopGraphRemove.Caption := 'Remove - ' + seriestitle;
+      mnuPopGraphDetails.Caption := 'Details - ' + seriestitle;
+      if FGraphSeries.Marks.Visible then showing := ' - turn off' else showing := ' - turn on';
+      mnuPopGraphValueMarks.Caption := 'Values - ' + seriestitle + showing;
+      mnuPopGraphValueMarks.Enabled := true;
+    end;
 end;
 
@@ -3016,4 +4046,6 @@
     mnuPopGraphDetails.Caption := 'Details...';
     mnuPopGraphDetails.Enabled := (lvwItemsTop.SelCount > 0) or (lvwItemsBottom.SelCount > 0);
+    mnuPopGraphValueMarks.Caption := 'Values - ';
+    mnuPopGraphValueMarks.Enabled := false;
   end
   else
@@ -3022,10 +4054,15 @@
     mnuPopGraphRemove.Enabled := true;
     mnuPopGraphDetails.Enabled := true;
-  end;
+    if chartDatelineTop.Tag <> -1 then
+      mnuPopGraphValueMarks.Enabled := true;
+  end;
+  {mnuPopGraphViewDefinition.Enabled := (pcTop.ActivePageIndex = 1)
+                                    or (pcBottom.ActivePageIndex = 1);}
   mnuPopGraphSwap.Enabled := (lvwItemsTop.SelCount > 0) or (lvwItemsBottom.SelCount > 0);
   mnuPopGraphReset.Enabled := mnuPopGraphSwap.Enabled;
   mnuPopGraphCopy.Enabled := mnuPopGraphSwap.Enabled;
   mnuPopGraphPrint.Enabled := mnuPopGraphSwap.Enabled;
-  
+  mnuPopGraphExport.Enabled := mnuPopGraphSwap.Enabled;
+
   with pnlMain.Parent do
   if BorderWidth <> 1 then            // only do on float Graph
@@ -3037,9 +4074,11 @@
 procedure TfrmGraphs.mnuPopGraphDetailsClick(Sender: TObject);
 var
-  aGraphItem: TGraphItem;
   tmpList: TStringList;
   date1, date2: TFMDateTime;
   teststring, typeitem, textvalue, textvalue1, textvalue2, typenum, typename: string;
-  i, selnum: integer;
+  selnum: integer;
+  aGraphItem: TGraphItem;
+  aListView: TListView;
+  aListItem: TListItem;
 begin
   if chartDatelineTop.Tag = 1 then               // series
@@ -3076,22 +4115,14 @@
     tmpList := TStringList.Create;
     if pnlTop.Tag = 1 then
-    for i := 0  to lvwItemsTop.Items.Count - 1 do
-    begin
-      if lvwItemsTop.Items[i].Selected then
-      begin
-        aGraphItem := TGraphItem(lvwItemsTop.Items.Item[i].SubItems.Objects[3]);      //get file^ien match
-        teststring := aGraphItem.Values;
-        tmpList.Add(teststring);
-      end;
-    end
+      aListView := lvwItemsTop
     else
-    for i := 0  to lvwItemsBottom.Items.Count - 1 do
-    begin
-      if lvwItemsBottom.Items[i].Selected then
-      begin
-        aGraphItem := TGraphItem(lvwItemsBottom.Items.Item[i].SubItems.Objects[3]);    //get file^ien match
-        teststring := aGraphItem.Values;
-        tmpList.Add(teststring);
-      end;
+      aListView := lvwItemsBottom;
+    aListItem := aListView.Selected;
+    while aListItem <> nil do
+    begin
+      aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);      //get file^ien match
+      teststring := aGraphItem.Values;
+      tmpList.Add(teststring);
+      aListItem := aListView.GetNextItem(aListItem, sdAll, [isSelected]);
     end;
     if tmpList.Count > 0 then
@@ -3100,15 +4131,20 @@
   end;
   FMouseDown := false;
+  if (Sender is TChart) then
+    (Sender as TChart).AllowZoom := false;
 end;
 
 procedure TfrmGraphs.AllDetails(aDate1, aDate2: TFMDateTime; aTempList: TStrings);
 var
-  TypeList: TStringList;
   i: integer;
   detailsok: boolean;
   testnum, teststring, testtype: string;
-begin
-  detailsok := true;
+  ztmpList: TStringList;
+  TypeList: TStringList;
+begin
+  //ShowMsg('This funtionality is currently unavailable.');
+  //exit;      // ****************** temporary 11-4-07
   TypeList := TStringList.Create;
+   detailsok := true;
   for i := 0 to aTempList.Count -1 do
   begin
@@ -3127,5 +4163,14 @@
   end;
   if detailsok then
-    ReportBox(rpcDetailSelected(Patient.DFN, aDate1, aDate2, TypeList, true), 'Graph results on ' + Patient.Name, True)
+  begin
+    ztmpList := TStringList.Create;
+    try
+      FastAssign(rpcDetailSelected(Patient.DFN, aDate1, aDate2, TypeList, true), ztmpList);
+      NotifyApps(ztmpList);
+      ReportBox(ztmpList, 'Graph results on ' + Patient.Name, True);
+    finally
+      ztmpList.Free;
+    end;
+  end
   else
     ItemDateRange(FGraphClick);
